; tri-bytes-at-once loader

.memorymap
slotsize $10000
defaultslot 0
slot 0 $ff80 $0040
.endme
.rombankmap
bankstotal 1
banksize $00040
banks 1
.endro
.emptyfill $ff

.bank 0 slot 0

start:
	; emulate "loaded a byte, and waiting next"
	; host must remember last kick value, and must not change $F4 until here...
	mov y, $F4
	inc y
	bra onebyte

loadstart:
	mov y, $F4
	bne loadstart
	; here, y == 0

onebyte:
	cmp y, $F4
	bne notready

	mov a, $F5
	mov [$00]+y, a
	; inc y later
	mov a, $F6
	mov x, $F7 ; prefetch
	mov $F4, y ; ack
	; first byte's inc y
	inc y
	bne +
	inc $01
+
	mov [$00]+y, a
	inc y
	bne +
	inc $01
+
	mov a, x ; write prefetched byte
	mov [$00]+y, a
	inc y
	bne +
	inc $01
+
	bra onebyte ; can be change to lsr a (for clearning N bit, only 2 cycle)?

notready:
	bpl onebyte

next:
	movw ya, $F6
	movw $00, ya

	movw ya, $F4
	mov $F4, a
	mov a, y
	mov x, a
	bne loadstart

	jmp [!$0000+x]
